MODULE RamBOx;
(*  2012-2014 Ari.Tao  * 09.05.97 + 20.11.12 *)
(*$S-,$T-,$Q+ Heap=0, Stack=1000                                 .

   Tiny tl to limit mem for WORD+, & other rambos.

   Als App zeigt RAMBO blo die drei grten freien Speicherblcke an.
   Als Acc kann es das RAM _etwas_ fragmentieren, um so 'nen paar lteren
   rcksichtslosen Prgn. die Mglichkeit zu nehmen, den gesamten Speicher
   fr sich allein zu reservieren. Beim Laden gilt:
   Hat es eine '1' als 6. Zeichen im Namen, versucht es, 1MB abzuspalten;
   ist es eine '2', so wird der grte freie Block zerteilt im Verhltnis
   1 : 1; wenn '3', dann im Verhltnis 3 : 3 : 2.
   8ung: Dies funzt leider nur mit seinem originalen Namen RAMBOx!
   =====  (Und auerdem nur, wenn das System ApplFind untersttzt!)
   Sonst aber wird auf den Benutzer gewartet.

   Hintergrund: Die frhen Versionen von TOS, MAGIC und MiNT haben das RAM
   ziemlich heillos zerstckelt. Diese sog. Speicher-Fragmentierung fhrt
   natrlich dazu, da irgendwann eher zufllig eine Prg.-Datei nicht mehr
   geladen werden kann, obwohl eigtl. genug Speicher vorhanden wre, weil
   ein Quantum RAM 'am Stck' gebraucht wird. Um dies Problem in den Griff
   zu kriegen, kamen ein paar Progr'er auf die Idee, mglichst viel Speicher
   in Form des 'grten Blocks' zu reservieren, um ihn selbst zu verwalten.
   Unter SingleTasking war solcher Egoismus ok, und bei MultiTasking fiel er
   nicht weiter auf, solange infolge Fragmentierung noch genug brig blieb.
   Neuere Versionen der Betriebssysteme wollen Fragmentierung vermeiden
   (damit auch mal 'groe Brocken' gefahren werden knnen), und so umfat
   der 'grte Block' fast den gesamten freien Speicher. Offensichtlich
   ist Speicher-Egoismus dann nicht mehr akzeptabel, man mu den Zugriff
   also einschrnken. Tut man das aber global auf Betriebssystem-Ebene (etwa
   durch ein INITIALMEM oder ein MAXMEM im MiNT.CNF), nimmt man den gerade
   erreichten Fortschritt stark zurck, weil nderungen unhandlich sind.
   Besser ist es, wenn man jedem Prg. individuell & leicht vernderbar den
   Speicher limitieren kann. Mglichkeiten dafr sind:
    1) Ein Eintrag im Prg.-Header (wurde historisch versumt)
    2) Ein am Prg,. angehngtes 'Tag' a la JINNEE (leider proprietr)
    3) Anmeldung im Desktop (fr jeden DT. & jedes Prg. erneut, aufwendig)
   RAMBO bietet eine global wirkende Alternative, die leicht zu ndern ist.

   Prg.techn. Bem.: Anscheinend kann man die drei grten Blcke im Speicher
   nur ermitteln, indem man sie alloziert. In dem Moment ist aber uU. fast
   der gesamte Speicher reserviert: RAMBO provoziert dann kurzfristig genau
   das Problem, vor dem es schtzen soll! Abhilfe: Mit IR-Prio [7] fr einen
   kurzen Moment Prozewechsel verbieten, Speicher sofort wieder freigeben!
*)
IMPORT AEB, SX;
FROM   Aux  IMPORT AD,LI,IG, LItoSt;
FROM   GDB  IMPORT Alloc, FreeA, Shrink;

CONST  AT =     "  RAM-BlockOption  ";
             (* 0123456789012345678901234567890 *)
       A0 = "[1][    2012 Goldetta Villasexta ";
       A1 =    "| shows RamBO's greatest hits: ";
       A2 =    "|    Block @: ";
       B0 = " Bytes ";
       F0 = "][    OK    ]";
       F1 = "][  Unfrag  | OK ]";
       F2 = "][  2 frax  | OK |  3 frax  ]";

VAR    A:     ARRAY [0..3] OF IG;
       N,R,S,
       ApId:  INTEGER;
       me,
       AlSt:  SX.STR;
       isAcc,
       aktiv,
       showA,
       virgo: BOOLEAN;

PROCEDURE Num2St (c: CHAR; VAR Sz: AD; VAR Size: ARRAY OF CHAR);
   VAR s: SX.S40;
 BEGIN LItoSt (LI (Sz), 8, s);
   SX.Add (A2, s, Size); SX.Apd (Size, B0); SX.xCh ('@',c, Size) END Num2St;

PROCEDURE Nums2Strs (n1,n2,n3: AD; VAR s1,s2,s3: SX.S40);
 BEGIN Num2St ('1', n1, s1); Num2St ('2', n2, s2); Num2St ('3', n3, s3);
   END Nums2Strs;


MODULE Intima [7];   (* Hohe IR-Prioritt, um Prozewechsel zu verhindern.*)
IMPORT Alloc,Shrink,FreeA, AD,LI,IG, aktiv,virgo, N,R,S;
EXPORT getBlocks, l1,l2;

VAR    l1,l2: AD;

PROCEDURE MaxAlloc (VAR Adr, Sz: AD);
 BEGIN Sz  := Alloc (-1);
       Adr := Alloc (Sz); IF (LI(Adr) <=0) THEN Sz := 0 END; END MaxAlloc;

PROCEDURE GetBlock (c: CHAR; VAR Adr, Sz: AD);
 BEGIN IF (c = '3') THEN Sz := Alloc (-1);            (* '3' nur anfragen *)
       ELSE MaxAlloc (Adr, Sz) END; END GetBlock;

PROCEDURE getBlocks (VAR n1,n2,n3: AD);
  VAR  r: IG; a1,a2,a3, m1,m2: AD;
  PROCEDURE Lock (a, m: AD; VAR l: AD);
    BEGIN r := Shrink (a, m); MaxAlloc (l, m); r := Shrink (l, 16) END Lock;
 BEGIN GetBlock ('1', a1, n1);     (* Den 1.Block schnellstens schrumpfen,*)
       GetBlock ('2', a2, n2);     (* den 2.Block schnellstens freigeben, *)
       GetBlock ('3', a3, n3);     (* den 3.Block mu man nich reserviern.*)
    IF ~ aktiv & ~ virgo THEN                     (* Keile bereitstellen. *)
       cl (n1, m1,m2); Lock (a1, m1, l1);
       IF (R = 3) THEN Lock (a1, m2, l2) ELSE l2 := NIL END; END;
    r := FreeA (a1);               (* Nur den grten sollte man spalten! *)
    r := FreeA (a2); END getBlocks;

PROCEDURE cl (n1: AD; VAR m1,m2: AD);             (* Bestimmung der Keile.*)
 BEGIN IF (N = 1) THEN IF    (n1  < 1234567) THEN R := 2;
                       ELSE   m1 := 1000000 END; END;            (* ~ 1MB *)
       IF (R = 2) THEN m1 := (n1 DIV 2) END;                     (* 1 : 1 *)
       IF (R = 3) THEN m1 := (n1 DIV 4) * 3;                     (* 6 : 2 *)
                       m2 := (m1 DIV 2) END; END cl;             (* 3 : 3 *)

END (*M*) Intima;


PROCEDURE setLocks (i: IG);        (* Die Keile besttigen oder verwerfen?*)
  PROCEDURE freeL; BEGIN i := FreeA (l2) + FreeA (l1) END freeL;
 BEGIN IF (i = 2) THEN
         IF ~ aktiv THEN freeL END; RETURN;
       ELSE   aktiv := ~ aktiv;
         IF ~ aktiv THEN freeL;
         ELSE S:= R; R := 2 + (i DIV 3);
           IF S # R THEN freeL; aktiv := FALSE END END END; END setLocks;

PROCEDURE Hit;
  VAR  r, d: IG; n1,n2,n3: AD; s1,s2,s3, se: SX.S40;
  PROCEDURE Dialog;
    BEGIN Nums2Strs (n1,n2,n3, s1,s2,s3);
          AlSt := A0; SX.Sew (AlSt, A1, s1,s2,s3, se,"");
       r := AEB.FormAlert (d, AlSt) END Dialog;
 BEGIN AEB.WindSem (AEB.UPDATE+AEB.MOCTRL);
       (* Dies --^ gengt nicht, um die Proze-Umschaltung zu blockieren! *)
  LOOP    getBlocks (n1,n2,n3);  d := 2;
       IF ~ isAcc THEN se := F0; d := 1; Dialog; EXIT;
    ELSE IF aktiv THEN se := F1 ELSE se := F2 END END;
    IF      virgo THEN virgo := FALSE; r := A[N]; (* Zwifach entjungfern: *)
    ELSIF ~ showA THEN showA := TRUE;  r := 2; aktiv := (N # 0);
    ELSIF (S # R) THEN S := R;
    ELSE   Dialog END;
    IF showA THEN setLocks (r) END;               (* Revolver-Schaltung!  *)
    IF r = 2 THEN EXIT END; END (*L*);
  AEB.WindSem (0); END Hit;

PROCEDURE RunAccPrg (VAR AccMenu: ARRAY OF CHAR; Job: PROC);
 VAR   MenId: INTEGER; M: AEB.MsgPipeR;
 BEGIN IF ~ AEB.ApplIsAcc ()  THEN Job; RETURN END;
       MenId := AEB.MenuRegist (ApId, AccMenu);
  LOOP AEB.EventMessage (M);
    IF (M.Type = AEB.ACCOPEN) THEN Job END;
    END (*L*); END RunAccPrg;
(*
PROCEDURE get6 (): IG;
 VAR   k,i, n: IG;      (* So geht's fr .PRG, aber leider nicht fr .ACC *)
 BEGIN k := 0; i := 0;
       Main.Call (me);
   WHILE (me[i] # 0c) & (i < 248) DO
      IF (me[i] = '\') THEN k := i+1 END; INC (i) END;
   INC (k, 5); n := ORD (CAP (me[k])) - ORD ('0');
   IF  (n > 3) OR (n < 0) THEN n := 0 END;
   RETURN n; END get6;
*)
PROCEDURE getN (): IG;
 BEGIN IF (-1 # AEB.ApplFind ("RAMBO3  ")) THEN RETURN 3 END;
       IF (-1 # AEB.ApplFind ("RAMBO2  ")) THEN RETURN 2 END;
       IF (-1 # AEB.ApplFind ("RAMBO1  ")) THEN RETURN 1 END;
   RETURN 0 END getN;

PROCEDURE InstDefault;
 BEGIN N := getN (); A[0] := 2; A[1] := 1; A[2] := 1; A[3] := 3;
       R := N; S := R; virgo := (N # 0); showA := FALSE; aktiv := FALSE;
  Hit; END InstDefault;

BEGIN l1 := 0; l2 := 0;
      me := "############  2012 Ari.Tao ###########";        (* Kosmetik.*)
      me := "############";
      ApId  := AEB.ApplInit ();
      isAcc := AEB.ApplIsAcc();
   IF isAcc THEN InstDefault END;           (* falls im Namen vorgegeben! *)
   RunAccPrg (AT, Hit);
   AEB.ApplExit; END RamBOx .
